Timeline.DateTime=new Object();
Timeline.DateTime.MILLISECOND=0;
Timeline.DateTime.SECOND=1;
Timeline.DateTime.MINUTE=2;
Timeline.DateTime.HOUR=3;
Timeline.DateTime.DAY=4;
Timeline.DateTime.WEEK=5;
Timeline.DateTime.MONTH=6;
Timeline.DateTime.YEAR=7;
Timeline.DateTime.DECADE=8;
Timeline.DateTime.CENTURY=9;
Timeline.DateTime.MILLENNIUM=10;
Timeline.DateTime.EPOCH=-1;
Timeline.DateTime.ERA=-2;
Timeline.DateTime.gregorianUnitLengths=[];
(function(){
var d=Timeline.DateTime;
var a=d.gregorianUnitLengths;
a[d.MILLISECOND]=1;
a[d.SECOND]=1000;
a[d.MINUTE]=a[d.SECOND]*60;
a[d.HOUR]=a[d.MINUTE]*60;
a[d.DAY]=a[d.HOUR]*24;
a[d.WEEK]=a[d.DAY]*7;
a[d.MONTH]=a[d.DAY]*31;
a[d.YEAR]=a[d.DAY]*365;
a[d.DECADE]=a[d.YEAR]*10;
a[d.CENTURY]=a[d.YEAR]*100;
a[d.MILLENNIUM]=a[d.YEAR]*1000;
})();
Timeline.DateTime.parseGregorianDateTime=function(o){
if(o==null){
return null;
}else{
if(o instanceof Date){
return o;
}
}
var s=o.toString();
if(s.length>0&&s.length<8){
var _5=s.indexOf(" ");
if(_5>0){
var _6=parseInt(s.substr(0,_5));
var _7=s.substr(_5+1);
if(_7.toLowerCase()=="bc"){
_6=1-_6;
}
}else{
var _6=parseInt(s);
}
var d=new Date(0);
d.setUTCFullYear(_6);
return d;
}
try{
return new Date(Date.parse(s));
}
catch(e){
return null;
}
};
Timeline.DateTime._iso8601DateRegExp="^(-?)([0-9]{4})("+["(-?([0-9]{2})(-?([0-9]{2}))?)","(-?([0-9]{3}))","(-?W([0-9]{2})(-?([1-7]))?)"].join("|")+")?$";
Timeline.DateTime.setIso8601Date=function(_9,_a){
var _b=Timeline.DateTime._iso8601DateRegExp;
var d=_a.match(new RegExp(_b));
if(!d){
throw new Error("Invalid date string: "+_a);
}
var _d=(d[1]=="-")?-1:1;
var _e=_d*d[2];
var _f=d[5];
var _10=d[7];
var _11=d[9];
var _12=d[11];
var _13=(d[13])?d[13]:1;
_9.setUTCFullYear(_e);
if(_11){
_9.setUTCMonth(0);
_9.setUTCDate(Number(_11));
}else{
if(_12){
_9.setUTCMonth(0);
_9.setUTCDate(1);
var gd=_9.getUTCDay();
var day=(gd)?gd:7;
var _16=Number(_13)+(7*Number(_12));
if(day<=4){
_9.setUTCDate(_16+1-day);
}else{
_9.setUTCDate(_16+8-day);
}
}else{
if(_f){
_9.setUTCDate(1);
_9.setUTCMonth(_f-1);
}
if(_10){
_9.setUTCDate(_10);
}
}
}
return _9;
};
Timeline.DateTime.setIso8601Time=function(_17,_18){
var _19="Z|(([-+])([0-9]{2})(:?([0-9]{2}))?)$";
var d=_18.match(new RegExp(_19));
var _1b=0;
if(d){
if(d[0]!="Z"){
_1b=(Number(d[3])*60)+Number(d[5]);
_1b*=((d[2]=="-")?1:-1);
}
_18=_18.substr(0,_18.length-d[0].length);
}
var _1c="^([0-9]{2})(:?([0-9]{2})(:?([0-9]{2})(.([0-9]+))?)?)?$";
var d=_18.match(new RegExp(_1c));
if(!d){
dojo.debug("invalid time string: "+_18);
return false;
}
var _1d=d[1];
var _1e=Number((d[3])?d[3]:0);
var _1f=(d[5])?d[5]:0;
var ms=d[7]?(Number("0."+d[7])*1000):0;
_17.setUTCHours(_1d);
_17.setUTCMinutes(_1e);
_17.setUTCSeconds(_1f);
_17.setUTCMilliseconds(ms);
return _17;
};
Timeline.DateTime.setIso8601=function(_21,_22){
var _23=(_22.indexOf("T")==-1)?_22.split(" "):_22.split("T");
Timeline.DateTime.setIso8601Date(_21,_23[0]);
if(_23.length==2){
Timeline.DateTime.setIso8601Time(_21,_23[1]);
}
return _21;
};
Timeline.DateTime.parseIso8601DateTime=function(_24){
try{
return Timeline.DateTime.setIso8601(new Date(0),_24);
}
catch(e){
return null;
}
};
Timeline.DateTime.roundDownToInterval=function(_25,_26,_27,_28,_29){
var _2a=_27*Timeline.DateTime.gregorianUnitLengths[Timeline.DateTime.HOUR];
var _2b=new Date(_25.getTime()+_2a);
var _2c=function(d){
d.setUTCMilliseconds(0);
d.setUTCSeconds(0);
d.setUTCMinutes(0);
d.setUTCHours(0);
};
var _2e=function(d){
_2c(d);
d.setUTCDate(1);
d.setUTCMonth(0);
};
switch(_26){
case Timeline.DateTime.MILLISECOND:
var x=_2b.getUTCMilliseconds();
_2b.setUTCMilliseconds(x-(x%_28));
break;
case Timeline.DateTime.SECOND:
_2b.setUTCMilliseconds(0);
var x=_2b.getUTCSeconds();
_2b.setUTCSeconds(x-(x%_28));
break;
case Timeline.DateTime.MINUTE:
_2b.setUTCMilliseconds(0);
_2b.setUTCSeconds(0);
var x=_2b.getUTCMinutes();
_2b.setTime(_2b.getTime()-(x%_28)*Timeline.DateTime.gregorianUnitLengths[Timeline.DateTime.MINUTE]);
break;
case Timeline.DateTime.HOUR:
_2b.setUTCMilliseconds(0);
_2b.setUTCSeconds(0);
_2b.setUTCMinutes(0);
var x=_2b.getUTCHours();
_2b.setUTCHours(x-(x%_28));
break;
case Timeline.DateTime.DAY:
_2c(_2b);
break;
case Timeline.DateTime.WEEK:
_2c(_2b);
var d=(_2b.getUTCDay()+7-_29)%7;
_2b.setTime(_2b.getTime()-d*Timeline.DateTime.gregorianUnitLengths[Timeline.DateTime.DAY]);
break;
case Timeline.DateTime.MONTH:
_2c(_2b);
_2b.setUTCDate(1);
var x=_2b.getUTCMonth();
_2b.setUTCMonth(x-(x%_28));
break;
case Timeline.DateTime.YEAR:
_2e(_2b);
var x=_2b.getUTCFullYear();
_2b.setUTCFullYear(x-(x%_28));
break;
case Timeline.DateTime.DECADE:
_2e(_2b);
_2b.setUTCFullYear(Math.floor(_2b.getUTCFullYear()/10)*10);
break;
case Timeline.DateTime.CENTURY:
_2e(_2b);
_2b.setUTCFullYear(Math.floor(_2b.getUTCFullYear()/100)*100);
break;
case Timeline.DateTime.MILLENNIUM:
_2e(_2b);
_2b.setUTCFullYear(Math.floor(_2b.getUTCFullYear()/1000)*1000);
break;
}
_25.setTime(_2b.getTime()-_2a);
};
Timeline.DateTime.roundUpToInterval=function(_32,_33,_34,_35,_36){
var _37=_32.getTime();
Timeline.DateTime.roundDownToInterval(_32,_33,_34,_35,_36);
if(_32.getTime()<_37){
_32.setTime(_32.getTime()+Timeline.DateTime.gregorianUnitLengths[_33]*_35);
}
};
Timeline.DateTime.incrementByInterval=function(_38,_39){
switch(_39){
case Timeline.DateTime.MILLISECOND:
_38.setTime(_38.getTime()+1);
break;
case Timeline.DateTime.SECOND:
_38.setTime(_38.getTime()+1000);
break;
case Timeline.DateTime.MINUTE:
_38.setTime(_38.getTime()+Timeline.DateTime.gregorianUnitLengths[Timeline.DateTime.MINUTE]);
break;
case Timeline.DateTime.HOUR:
_38.setTime(_38.getTime()+Timeline.DateTime.gregorianUnitLengths[Timeline.DateTime.HOUR]);
break;
case Timeline.DateTime.DAY:
_38.setUTCDate(_38.getUTCDate()+1);
break;
case Timeline.DateTime.WEEK:
_38.setUTCDate(_38.getUTCDate()+7);
break;
case Timeline.DateTime.MONTH:
_38.setUTCMonth(_38.getUTCMonth()+1);
break;
case Timeline.DateTime.YEAR:
_38.setUTCFullYear(_38.getUTCFullYear()+1);
break;
case Timeline.DateTime.DECADE:
_38.setUTCFullYear(_38.getUTCFullYear()+10);
break;
case Timeline.DateTime.CENTURY:
_38.setUTCFullYear(_38.getUTCFullYear()+100);
break;
case Timeline.DateTime.MILLENNIUM:
_38.setUTCFullYear(_38.getUTCFullYear()+1000);
break;
}
};
Timeline.DateTime.removeTimeZoneOffset=function(_3a,_3b){
return new Date(_3a.getTime()+_3b*Timeline.DateTime.gregorianUnitLengths[Timeline.DateTime.HOUR]);
};

